Public Class CustomerDetail

    Private _CustomerID As String

    Protected Overrides Sub OnLoad(ByVal e As System.EventArgs)
        MyBase.OnLoad(e)

        SetDataFieldsEnabled(Not String.IsNullOrEmpty(_CustomerID))

    End Sub

    Protected Overrides Sub OnShown(ByVal e As System.EventArgs)
        MyBase.OnShown(e)
        m_txtCompanyName.Focus()
    End Sub

    Public Property CustomerID() As String
        Get
            Return _CustomerID
        End Get
        Set(ByVal value As String)
            _CustomerID = value
            DisplayCustomerDetails()
        End Set
    End Property

    Private Sub m_txtID_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_txtID.GotFocus

        AcceptButton = Nothing

    End Sub

    Private Sub m_txtID_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles m_txtID.KeyPress

        If e.KeyChar = ControlChars.Cr Then
            e.Handled = True
            m_txtID.Text = m_txtID.Text.ToUpper
            _CustomerID = m_txtID.Text
            DisplayCustomerDetails()
            m_txtID.SelectAll()
        End If

    End Sub

    Private Sub m_txtID_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles m_txtID.LostFocus

        _CustomerID = m_txtID.Text
        DisplayCustomerDetails()
        AcceptButton = m_btnOK

    End Sub

    Private Sub m_txtID_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles m_txtID.TextChanged

        SetDataFieldsEnabled(False)

    End Sub

    Private Sub DisplayCustomerDetails()
        Dim DB As IDataService
        Dim Customer As CustomersFetch

        Customer = New CustomersFetch
        Customer.ID = _CustomerID
        DB = New SqlServerDataService
        DB.ConnectionName = "Default"
        DB.Execute(Customer)
        If Customer.Found Then
            m_lblHeader.Text = Customer.CompanyName
            m_txtID.Text = _CustomerID
            m_txtAddress.Text = Customer.Address
            m_txtCity.Text = Customer.City
            m_txtCompanyName.Text = Customer.CompanyName
            m_txtContact.Text = Customer.ContactName
            m_txtCountry.Text = Customer.Country
            m_txtFax.Text = Customer.Fax
            m_txtPhone.Text = Customer.Phone
            m_txtPostalCode.Text = Customer.PostalCode
            m_txtRegion.Text = Customer.Region
            m_txtTitle.Text = Customer.ContactTitle
            SetDataFieldsEnabled(True)
        Else
            m_lblHeader.Text = "Not Found"
            SetDataFieldsEnabled(False)
        End If


    End Sub

    Private Sub SetDataFieldsEnabled(ByVal value As Boolean)

        m_capID.Enabled = value
        m_txtCompanyName.Enabled = value
        m_capCompanyName.Enabled = value
        m_txtContact.Enabled = value
        m_capContactName.Enabled = value
        m_txtTitle.Enabled = value
        m_capTitle.Enabled = value
        m_txtAddress.Enabled = value
        m_capAddress.Enabled = value
        m_txtCity.Enabled = value
        m_capCity.Enabled = value
        m_txtRegion.Enabled = value
        m_capRegion.Enabled = value
        m_txtPostalCode.Enabled = value
        m_capPostalCode.Enabled = value
        m_txtCountry.Enabled = value
        m_capCountry.Enabled = value
        m_txtPhone.Enabled = value
        m_capPhone.Enabled = value
        m_txtFax.Enabled = value
        m_capFax.Enabled = value
        m_btnOK.Enabled = value

    End Sub

End Class

